// ---------------------------------------------------------------------------------
//
// Tresor.CPP                                                 Ulrich Mller 01.07.07
//                                                            PCS1700       VC++ 6.0
// Profi Computing 1991 Experimentierbuch : Tresor
//
// ---------------------------------------------------------------------------------

#include "RoboFish\roboFish.h"

#define mTresor           1
#define mFehler           4
#define eCodeTaste1       1
#define eCodeTaste2       2
#define eCodeTaste3       3
#define eCodeTaste4       4
#define eTresorSchliessen 4
#define eTresorOffen      5
#define eTresorZu         6
#define dSchliessen       2
#define dOeffnen          1
#define dEin              1
#define dAus              0

UCHAR main(void)
{
	UCHAR CodeZahl;
	UCHAR IStat;
	UCHAR i;
  InitFish();
	Pause(1000);
	do {
		SetMotor(mTresor, dSchliessen);
		WaitForInput(eTresorZu);
		SetMotor(mTresor, dAus);

		CodeZahl = 0;
		for(i = 1; i < 8; i *= 2) {
			IStat = 0;
		  while(IStat == 0) {IStat = GetInputs() & 0xF; Pause(44);}
		  CodeZahl += IStat * i;
		  while(IStat != 0) {IStat = GetInputs() & 0xF; Pause(44);}
		}
		if (CodeZahl == 42) {
			SetMotor(mTresor, dOeffnen);
			WaitForInput(eTresorOffen);
			SetMotor(mTresor, dAus);
			WaitForInput(eTresorSchliessen);
		}
		else {
			SetMotor(mFehler, dEin);
			Pause(2345);
			SetMotor(mFehler, dAus);
		}

	} while(1);
	return(0);
}